// -----------------------------------------------------------
// Bit library v1.3 implementation file
// Copyright (C) 2005-2006 DJ-Andrey-sXe. All rights Reserved.
// License: GPL
// -----------------------------------------------------------

#include "libbit.h"

#define impl_SetBit(T) \
  void SetBit ( T* p, unsigned char offset ) \
  { *p |= (1 << offset); }

#define impl_SetBit64(T) \
  void SetBit ( T* p, unsigned char offset ) \
  { *p |= ( (__int64)1 << offset); }

#define impl_GetBit(T) \
  bool GetBit ( T* p, unsigned char offset ) \
  { return ( (int) ( *p & (1 << offset) ) ); }

#define impl_GetBit64(T) \
  bool GetBit ( T* p, unsigned char offset ) \
  { return ( (int) ( *p & ( (__int64)1 << offset) ) ); }
  
// Sets
impl_SetBit   ( unsigned char    )
impl_SetBit   ( signed   char    )
impl_SetBit   ( unsigned short   )
impl_SetBit   ( signed   short   )
impl_SetBit   ( unsigned long    )
impl_SetBit   ( signed   long    )
impl_SetBit64 ( unsigned __int64 )
impl_SetBit64 ( signed   __int64 )

// Gets
impl_GetBit   ( unsigned char    )
impl_GetBit   ( signed   char    )
impl_GetBit   ( unsigned short   )
impl_GetBit   ( signed   short   )
impl_GetBit   ( unsigned long    )
impl_GetBit   ( signed   long    )
impl_GetBit64 ( unsigned __int64 )
impl_GetBit64 ( signed   __int64 )

namespace __sys_appendix { char *appendix = "\r\n\r\nlibbit-1.3 (C) 2005-2006 by DJ-Andrey-sXe\r\n\r\n"; }
